'ping_schrt3.bas
'ber Potenziometer voreinstellbarer Imulszhler
'Mit Taste "Aufwrts" wird von einem einstellbaren Wert bis max. 999 hochgezhlt,
'Mit Taste "Abwrts" wird abwrtsgezhlt.
'Februar 2010
'Hermann Nieder
$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Leds(12) As Word
Dim W As Word
Dim D As Byte
Dim N As Word

Dim X As Byte
Dim Y As Byte

Dim Zeichen As Byte
Dim Splt1 As Word
Dim Splt2 As Word
Dim Splt3 As Word
Dim Splt4 As Word
Dim Hunderter As Word
Dim Hunderter1 As Word
Dim Zehner As Word
Dim Zehner1 As Word
Dim Einer As Byte
Dim Dat As Word
Dim Dat_temp As Word
Dim Z_bit As Bit



Declare Sub Initialisierung

Declare Sub Led1(byval X As Byte , Byval Y As Byte)
Declare Sub Led0(byval X As Byte , Byval Y As Byte)

Initialisierung

Dim Xx As Single
Dim Yy As Single
'LED am zugeordneten Flip-Flop-Ausgang leuchtet.
Z_bit = 0
Portb.6 = 0
Portb.7 = 1
Wait 1
' Solange keiner der beiden Interrupts INT0 und INT1 ausgelst  wird,
' wird fortwhrend mit einer Pause von 1 Sekunde die Spannung am AD-Eingang ADC6 eingelesen
' und der dafr ermittelte Wert mit den LEDs angezeigt. Dies ermglicht eine Voreinstellung des Impulszhlers
' mit einem der Potenziometer des Ping-Pong-Bausatzes.
' Es kann je nach Stellung des Potenziometerschleifkontakts ein Wert zwischen 0 und 999 eingestellt werden.

Anfang:
'Jetzt ist das Z_bit 1, der eingelesene Wert liegt fest
'und das Programm wird bei Weiter fortgesetzt.
If Z_bit = 1 Then
Portb.6 = 1
Portb.7 = 0
Goto Weiter
End If
Dat = Getadc(6)
Dat_temp = Dat
Gosub Dez_darst
Portb.6 = 0
Portb.7 = 1
Waitms 1000
Goto Anfang


Weiter:
Do
Enable Int0
Enable Int1
Dat = Dat_temp
'Es erfolgt stndig fr den momentanen Wert der Variablen
'Dat_temp die Darstellung als Dezimalzahl
Gosub Dez_darst
Waitms 20
Loop


'Darstellung im Dezimalformat
Dez_darst:
Hunderter = Dat / 100
Zeichen = Hunderter
Gosub Darstellung1
Hunderter1 = Hunderter * 100
Dat = Dat - Hunderter1
Zehner = Dat / 10
Zeichen = Zehner

Gosub Darstellung2
Zehner1 = Zehner * 10
Dat = Dat - Zehner1
Einer = Dat

Zeichen = Einer
Gosub Darstellung3

Return

'Zeichen links
Darstellung1:                                               '
Gosub Zeichen_z
Leds(1) = Splt1
Leds(2) = Splt2
Leds(3) = Splt3
Leds(4) = Splt4
Return
'Zeichen Mitte
Darstellung2:
Gosub Zeichen_z
Leds(5) = Splt1
Leds(6) = Splt2
Leds(7) = Splt3
Leds(8) = Splt4
Return
'zeichen rechts
Darstellung3:
Gosub Zeichen_z
Leds(9) = Splt1
Leds(10) = Splt2
Leds(11) = Splt3
Leds(12) = Splt4
Return

'Die Muster fr die Zeichen (Ziffern der Anzeige)
'wurden mit dem Programm "Super-Mustergenerator"
'entwickelt und die Werte daraus jeweils in die
'Programmzeilen Splt1..Splt4 bernommen.
Zeichen_z:
Select Case Zeichen
Case 0:
Splt1 = 0
Splt2 = 124
Splt3 = 68
Splt4 = 124
Case 1:
Splt1 = 0
Splt2 = 0
Splt3 = 8
Splt4 = 124
Case 2:
Splt1 = 0
Splt2 = 116
Splt3 = 84
Splt4 = 92
Case 3:
Splt1 = 0
Splt2 = 84
Splt3 = 84
Splt4 = 124

Case 4:
Splt1 = 0
Splt2 = 28
Splt3 = 16
Splt4 = 124
Case 5:
Splt1 = 0
Splt2 = 92
Splt3 = 84
Splt4 = 116
Case 6:
Splt1 = 0
Splt2 = 124
Splt3 = 84
Splt4 = 116
Case 7:
Splt1 = 0
Splt2 = 4
Splt3 = 4
Splt4 = 124
Case 8:
Splt1 = 0
Splt2 = 124
Splt3 = 84
Splt4 = 124
Case 9:
Splt1 = 0
Splt2 = 92
Splt3 = 84
Splt4 = 124
End Select
Return




Sub Led1(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 1
    Case 2 : Leds(x).8 = 1
    Case 3 : Leds(x).7 = 1
    Case 4 : Leds(x).6 = 1
    Case 5 : Leds(x).5 = 1
    Case 6 : Leds(x).4 = 1
    Case 7 : Leds(x).3 = 1
    Case 8 : Leds(x).2 = 1
    Case 9 : Leds(x).1 = 1
    Case 10 : Leds(x).0 = 1
   End Select
  End If
End Sub

Sub Led0(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 0
    Case 2 : Leds(x).8 = 0
    Case 3 : Leds(x).7 = 0
    Case 4 : Leds(x).6 = 0
    Case 5 : Leds(x).5 = 0
    Case 6 : Leds(x).4 = 0
    Case 7 : Leds(x).3 = 0
    Case 8 : Leds(x).2 = 0
    Case 9 : Leds(x).1 = 0
    Case 10 : Leds(x).0 = 0
   End Select
  End If
End Sub


'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = &B00011111                                 'PORTC als AD-Eingang
  Ddrb = &B11111111                                         'gendert gegenber Vorlage
  'PD2/INT0 und PD3/INT1 sind Eingnge
  Ddrd = &B11110010
  'Config Portd = &B1111111
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2
 'Festlegungen fr ADC-Wandlung
 Config Adc = Single , Prescaler = 64 , Reference = Off
 Start Adc
  'Festlegungen fr INT0, fallende Flanke
  'lst Interrupt aus
  Config Int0 = Falling                                     'war Low Level
  Enable Int0
  On Int0 Int0_isr

  'und INT1, Interrup-Auslsung ebenfalls
  'bei fallender Flanke
  Config Int1 = Falling                                     'war Low Level
  Enable Int1
  On Int1 Int1_isr

  End Sub
  'Festlegung,dass ein Z_Bit gesetzt wird
  'und die Variable Dat_temp bei jedem
  'Aufruf um 1 erhht wird, bis 999
  'erreicht wird, da dies die grtmgliche
  'Anzeige auf den LEDs der Ping-Pong-Platine ist
  Int0_isr:
  Z_bit = 1
  Incr Dat_temp
  If Dat > 999 Then
  Dat = 999
  End If
  Disable Int0
  Return
  'Auch bei Auslsung von INT1 wird das Z_bit
  ' gesetzt,allerdings wird hier die Variable
  'Dat_temp jeweils um 1 erniedrigt, wobei
  'als unterste Grenze 0 festgelegt ist.
  Int1_isr:
  Z_bit = 1
  Decr Dat_temp
  If Dat < 0 Then
  Dat = 0
  End If
  Disable Int1
  Return


'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return
End